"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReadWebPage = exports.getServerSidePropsForReadWebPage = void 0;
var react_1 = __importStar(require("react"));
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var site_record_1 = __importDefault(require("../../sections/site-record"));
var site_error_1 = __importDefault(require("../../sections/site-error"));
var css_1 = __importDefault(require("primeobjects-ui-web-store/build/cjs/css"));
// import { getRecordServerSideProps, getBasicServerSideProps } from "../../../components/ui-web-application/page/server";
var server_1 = require("../../page/server");
var core_1 = require("primeobjects-helper-util/build/cjs/core");
var site_base_1 = __importDefault(require("../../page/site-base"));
var util_1 = require("../../page/util");
var html_read_1 = require("../../controls/html-read");
var site_page_single_1 = __importDefault(require("../../sections/site-page-single"));
var site_page_split_1 = __importDefault(require("../../sections/site-page-split"));
var util_2 = require("../../util");
var PRISM_CSS = "\n    :not(pre) > code[class*=\"language-\"], pre[class*=\"language-\"] \n    {\n        background: #ffffff !important;\n        padding: 0;\n    }\n";
var getServerSidePropsForReadWebPage = function (props) { return __awaiter(void 0, void 0, void 0, function () {
    var entityName, entityType, includeList, cacheExpireMinutes, basicServerSideProps;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                entityName = props.entityName, entityType = props.entityType, includeList = props.includeList, cacheExpireMinutes = props.cacheExpireMinutes;
                return [4 /*yield*/, (0, server_1.getBasicServerSideProps)(props)];
            case 1:
                basicServerSideProps = _a.sent();
                return [4 /*yield*/, (0, server_1.getRecordServerSideProps)(basicServerSideProps, entityName !== null && entityName !== void 0 ? entityName : "Content", entityType, includeList, cacheExpireMinutes)];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.getServerSidePropsForReadWebPage = getServerSidePropsForReadWebPage;
var SiteRecordSection = undefined;
var ReadWebPage = function (props) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    var SiteBasePage = (_a = props.SiteBasePage) !== null && _a !== void 0 ? _a : site_base_1.default;
    if (!SiteRecordSection) {
        console.log("Get global components in /pages/read/web-page.tsx");
        SiteRecordSection = (0, util_2.getGlobalComponent)("SiteRecordSection", site_record_1.default);
    }
    var host = props.host, data = props.data, query = props.query, organization = props.organization, solution = props.solution, domain = props.domain, port = props.port, appTrack = props.appTrack;
    var site = solution === null || solution === void 0 ? void 0 : solution.site;
    var navigation = site === null || site === void 0 ? void 0 : site.navigation;
    var primaryColor = solution === null || solution === void 0 ? void 0 : solution.color;
    var introduction = site === null || site === void 0 ? void 0 : site.introduction;
    var supportOrganizationBrand = props.supportOrganizationBrand == true;
    var record = (0, core_1.isObject)(props.record)
        ? __assign(__assign({}, props.record), { title: (0, primeobjects_helper_util_1.getRecordDisplay)(props.record) }) : {};
    (0, react_1.useEffect)(function () {
        (0, util_1.handleReadModeTooltips)(record);
    }, [record]);
    var description = record.description
        ? record.description
        : record.summary
            ? record.summary
            : "";
    if (description.length > 150)
        description.substring(0, 150) + " ...";
    return (react_1.default.createElement(SiteBasePage, __assign({}, props, { solution: solution, appTrack: appTrack, headProps: __assign(__assign({}, props.headProps), { host: host, url: record.nameBasedEndpoint, canonical: record.canonicalEndpoint, title: record.title, image: record.media, description: description, domain: domain, port: port, cssList: [
                "https://cdn.jsdelivr.net/npm/prismjs@1.29.0/themes/prism.css",
                "/css/prism-js-fold.css"
            ] }), siteOrgName: supportOrganizationBrand && (organization === null || organization === void 0 ? void 0 : organization.siteName)
            ? organization === null || organization === void 0 ? void 0 : organization.name
            : undefined, siteName: supportOrganizationBrand && (organization === null || organization === void 0 ? void 0 : organization.siteName), siteLogo: supportOrganizationBrand && (organization === null || organization === void 0 ? void 0 : organization.siteLogo), currentContextSettings: {
            needAuthorization: false,
            skipAuthentication: false
        } }),
        react_1.default.createElement(css_1.default, { id: "read-css", content: "".concat((0, html_read_1.getTooltipCSS)(primaryColor), " \n ").concat(PRISM_CSS, "}") }),
        record.id ? (react_1.default.createElement(site_page_single_1.default, null,
            react_1.default.createElement(SiteRecordSection, __assign({ solution: solution, record: record, maxTagCount: 15, flushCache: query === null || query === void 0 ? void 0 : query.flushCache, navigation: navigation, similarSectionAdditionalData: data }, props.recordSectionProps, { urlTemplate: (_c = (_b = props.recordSectionProps) === null || _b === void 0 ? void 0 : _b.urlTemplate) !== null && _c !== void 0 ? _c : "/read/[PH.SLUG]", tagSectionTitle: (_e = (_d = props.recordSectionProps) === null || _d === void 0 ? void 0 : _d.tagSectionTitle) !== null && _e !== void 0 ? _e : "Tags", similarSectionTitle: (_g = (_f = props.recordSectionProps) === null || _f === void 0 ? void 0 : _f.similarSectionTitle) !== null && _g !== void 0 ? _g : "More Readings", submitEmailSettings: (_j = (_h = props.recordSectionProps) === null || _h === void 0 ? void 0 : _h.submitEmailSettings) !== null && _j !== void 0 ? _j : introduction.submitEmailSettings })))) : (react_1.default.createElement(site_page_split_1.default, null,
            react_1.default.createElement(site_error_1.default, { reason: query.token &&
                    "The token may be invalid or expired." }))),
        react_1.default.createElement("script", { src: "https://cdn.jsdelivr.net/npm/prismjs@1.29.0/components/prism-core.min.js" }),
        react_1.default.createElement("script", { src: "https://cdn.jsdelivr.net/npm/prismjs@1.29.0/plugins/autoloader/prism-autoloader.min.js" }),
        react_1.default.createElement("script", { src: "https://cdn.jsdelivr.net/npm/prismjs@1.29.0/plugins/keep-markup/prism-keep-markup.min.js" }),
        react_1.default.createElement("script", { src: "/js/prism-js-fold.js" })));
};
exports.ReadWebPage = ReadWebPage;
exports.default = exports.ReadWebPage;
//# sourceMappingURL=web-page.js.map