"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListTableSection = void 0;
var react_1 = __importStar(require("react"));
var lodash_1 = require("lodash");
var table_1 = __importDefault(require("../table"));
var auth_call_api_1 = require("../../context/auth-call-api");
var use_current_context_1 = require("../../context/use-current-context");
var primeobjects_ui_web_basic_1 = require("primeobjects-ui-web-basic");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var util_1 = require("./util");
var css_1 = __importDefault(require("primeobjects-ui-web-store/build/cjs/css"));
var table_css_1 = require("./table-css");
var loading_1 = __importDefault(require("./loading"));
var index_1 = require("primeobjects-helper-ui/build/cjs/index");
var util_2 = require("../../util");
var ListTableSection = function (props) {
    var _a, _b, _c, _d;
    var recordToUpdate = props.recordToUpdate, recordDeleted = props.recordDeleted, showTags = props.showTags, recordInAction = props.recordInAction, manualLoadMore = props.manualLoadMore, apis = props.apis, defaultRecordId = props.defaultRecordId, minWidth = props.minWidth, showScrollbarX = props.showScrollbarX;
    var solution = (0, index_1.useSolution)();
    var _e = (0, react_1.useState)(undefined), query = _e[0], setQuery = _e[1];
    var _f = (0, react_1.useState)(undefined), result = _f[0], setResult = _f[1];
    var _g = (0, react_1.useState)(true), loading = _g[0], setLoading = _g[1];
    var _h = (0, react_1.useState)(""), error = _h[0], setError = _h[1];
    var getColumns = props.getColumns
        ? props.getColumns
        : util_1.DEFAULT_LIST_COLUMNS;
    var primaryColor = (0, index_1.usePrimaryColor)();
    var data = result ? result.data : [];
    var entity = (0, primeobjects_helper_util_1.getEntity)(solution, query === null || query === void 0 ? void 0 : query.entityName, query === null || query === void 0 ? void 0 : query.entityType);
    var entityName = entity === null || entity === void 0 ? void 0 : entity.entityName;
    var entityType = entity === null || entity === void 0 ? void 0 : entity.entityType;
    var tableId = "table-".concat(entityName).concat(entityType ? "-" + entityType : "");
    var wrapperClassName = (_a = props.wrapperClassName) !== null && _a !== void 0 ? _a : "";
    var wrapperStyle = (_b = props.wrapperStyle) !== null && _b !== void 0 ? _b : {};
    var tableWrapperClassName = (_c = props.tableWrapperClassName) !== null && _c !== void 0 ? _c : "";
    var tableWrapperStyle = (_d = props.tableWrapperStyle) !== null && _d !== void 0 ? _d : {};
    var tableSectionWrapper = (0, react_1.useRef)(null);
    var currentContext = (0, use_current_context_1.useCurrentContext)(solution, {
        componentName: "/pages/list-table.tsx"
    });
    var cacheKey = query &&
        (0, lodash_1.isNumber)(query.localCacheExpiredInSeconds) &&
        query.localCacheExpiredInSeconds >= 1 &&
        !(0, primeobjects_helper_util_1.isNonEmptyString)(query.keywords) &&
        query.name == "first"
        ? "list-table-query-".concat(query.entityName, "-").concat(query.entityType, "-").concat(query.scope, "-").concat(query.keywords)
        : undefined;
    var abortController = (0, react_1.useRef)();
    (0, react_1.useEffect)(function () {
        if (recordToUpdate && result) {
            if ((0, lodash_1.find)(result.data, function (r) {
                return r.id == recordToUpdate.id;
            })) {
                setResult(__assign(__assign({}, result), { data: (0, lodash_1.map)(result.data, function (r) {
                        return r.id == recordToUpdate.id ? recordToUpdate : r;
                    }) }));
            }
            else {
                setResult(__assign(__assign({}, result), { data: __spreadArray([(0, lodash_1.cloneDeep)(recordToUpdate)], result.data, true) }));
            }
            cacheKey && (0, primeobjects_helper_util_1.removeCache)(cacheKey);
        }
    }, [JSON.stringify(recordToUpdate)]);
    (0, react_1.useEffect)(function () {
        if (recordDeleted && result) {
            setResult({
                count: result.count - 1,
                data: (0, lodash_1.filter)(result.data, function (r) { return r.id != recordDeleted.id; })
            });
            cacheKey && (0, primeobjects_helper_util_1.removeCache)(cacheKey);
        }
    }, [JSON.stringify(recordDeleted)]);
    (0, react_1.useEffect)(function () {
        setResult(undefined);
        setQuery(props.query);
    }, [props.query]);
    (0, react_1.useEffect)(function () {
        if (!(0, lodash_1.isNil)(props.refresh) && (0, primeobjects_helper_util_1.isNonEmptyString)("".concat(props.refresh))) {
            setQuery(__assign(__assign({}, props.query), { name: "refresh" }));
        }
    }, [props.refresh]);
    var onLoadError = function (query, error) {
        if ((error === null || error === void 0 ? void 0 : error.message) != "canceled") {
            console.error(error);
            setError("Sorry, failed to load ".concat(entity === null || entity === void 0 ? void 0 : entity.uiCollectionName, "."));
            props.onLoadFailed && props.onLoadFailed(query, error);
            setLoading(false);
            abortController.current = null;
        }
    };
    var onLoadSuccess = function (query, result, cacheKey) {
        setResult(result);
        setLoading(false);
        abortController.current = null;
        if (cacheKey) {
            (0, primeobjects_helper_util_1.setCache)(cacheKey, {
                query: query,
                result: result
            }, query.localCacheExpiredInSeconds);
        }
        props.onLoadSuccess && props.onLoadSuccess(query, result);
    };
    (0, react_1.useEffect)(function () {
        var _a;
        if (query) {
            if (query.name != "more")
                setResult(undefined);
            (_a = abortController.current) === null || _a === void 0 ? void 0 : _a.abort();
            abortController.current = new AbortController();
            setLoading(true);
            setError("");
            var apiEndpoint = apis
                ? (0, util_2.getApiEndpointBase)(apis, "data", "query")
                : (0, util_2.getApiEndpoint)(solution, "data", "query", entity === null || entity === void 0 ? void 0 : entity.entityName);
            if ((0, primeobjects_helper_util_1.isNonEmptyString)(query.keywords)) {
                query.keywords = query.keywords
                    .trim()
                    .replace(new RegExp("( ){2,}", "g"), " ");
                var localQueryService = (0, primeobjects_ui_web_basic_1.getLocalStorage)("query-service-".concat(query.entityName));
                query.service =
                    query.service != "hidden"
                        ? localQueryService
                            ? localQueryService
                            : query.service
                                ? query.service
                                : "auto"
                        : "auto";
                if (query.service == "auto") {
                    query.service =
                        query.keywords.split(" ").length > 1
                            ? "elastic"
                            : "database";
                }
                apiEndpoint = apis
                    ? (0, util_2.getApiEndpointBase)(apis, "data", "search")
                    : (0, util_2.getApiEndpoint)(solution, "data", "search", entity === null || entity === void 0 ? void 0 : entity.entityName);
            }
            if (cacheKey) {
                var cacheResult = (0, primeobjects_helper_util_1.getCache)(cacheKey);
                if (cacheResult &&
                    JSON.stringify(cacheResult.query) == JSON.stringify(query)) {
                    return onLoadSuccess(query, cacheResult.result);
                }
            }
            apiEndpoint &&
                (0, auth_call_api_1.callApi)(solution, apiEndpoint, 
                // "http://localhost:3000/prod/query",
                defaultRecordId
                    ? {
                        query: query,
                        id: defaultRecordId,
                        entityName: query.entityName
                    }
                    : { query: query }, "post", {
                    abortSignal: abortController.current.signal
                })
                    .then(function (r) {
                    var newResult = { count: 0, data: [] };
                    switch (query.name) {
                        case "more": {
                            newResult = {
                                count: (result === null || result === void 0 ? void 0 : result.count) + r.count,
                                continuation: r.continuation,
                                data: __spreadArray(__spreadArray([], (result ? result.data : {}), true), r.data, true)
                            };
                            break;
                        }
                        default: {
                            newResult = r;
                            break;
                        }
                    }
                    if (props.onLoadPostProcess) {
                        props
                            .onLoadPostProcess(query, newResult)
                            .then(function (postResult) {
                            onLoadSuccess(query, postResult, cacheKey);
                        })
                            .catch(function (error) {
                            onLoadError(query, error);
                            abortController.current = null;
                        });
                    }
                    else {
                        onLoadSuccess(query, newResult, cacheKey);
                    }
                })
                    .catch(function (error) {
                    onLoadError(query, error);
                    abortController.current = null;
                });
        }
    }, [query]);
    var onClickFooterLoadMore = function () {
        if (tableSectionWrapper.current &&
            !(0, lodash_1.isNil)(tableSectionWrapper.current.scrollTop)) {
            tableSectionWrapper.current.scrollTop =
                tableSectionWrapper.current.scrollHeight;
        }
    };
    var onLoadMore = (0, lodash_1.debounce)(function () {
        query &&
            setQuery(__assign(__assign({}, query), { name: "more", pageNumber: query.pageNumber + 1 }));
    }, 200);
    var onScrollList = function (e) {
        //console.log({ a: Math.abs(e.target.scrollHeight - e.target.scrollTop - e.target.clientHeight), b: result?.continuation, c: loading });
        if (Math.abs(e.target.scrollHeight -
            e.target.scrollTop -
            e.target.clientHeight) < 15 &&
            !(0, lodash_1.isNil)(result === null || result === void 0 ? void 0 : result.continuation) &&
            !(0, primeobjects_helper_util_1.isNonEmptyString)(loading) &&
            manualLoadMore != true) {
            onLoadMore();
        }
    };
    var renderLoadingMore = function () {
        return ((result === null || result === void 0 ? void 0 : result.continuation) && (react_1.default.createElement("div", { className: "w-full flex justify-center py-5" },
            react_1.default.createElement("div", { className: "flex flex-col items-center justify-center" }, (query === null || query === void 0 ? void 0 : query.name) == "more" ? (react_1.default.createElement(primeobjects_ui_web_basic_1.SVG, { src: "/icons/platform/loading.svg", className: "spinner", style: { width: 30, height: 30 } })) : (react_1.default.createElement(primeobjects_ui_web_basic_1.SVG, { src: "/icons/platform/down.svg", className: "cursor-pointer", style: { width: 30, height: 30 }, onClick: onLoadMore }))))));
    };
    var renderEmpty = function () {
        if (data.length > 0 || loading)
            return null;
        return props.renderEmpty && props.renderEmpty();
    };
    var renderError = function () {
        if (!(0, primeobjects_helper_util_1.isNonEmptyString)(error))
            return null;
        return (react_1.default.createElement("div", { className: "w-full text-base p-4 flex flex-col text-red-600" }, error));
    };
    var renderLoading = function () {
        if (!loading || (query && query.name == "more"))
            return null;
        return (react_1.default.createElement(loading_1.default, { id: "list-table-loading", height: 60, count: 3, barHeight: 10, widthAdj: -30 }));
    };
    var onRowSelected = function (newSelectedIds, newSelectedRecords) {
        if (props.onRowSelected)
            props.onRowSelected(newSelectedIds, newSelectedRecords);
    };
    var onClickRecord = function (record, action, entity, rowIndex) {
        switch (action) {
            case "read": {
                props.onReadRecord &&
                    props.onReadRecord(record, action, entity, rowIndex);
                break;
            }
            case "delete": {
                props.onDeleteRecord &&
                    props.onDeleteRecord(record, action, entity, rowIndex);
                break;
            }
            case "clone": {
                props.onCloneRecord &&
                    props.onCloneRecord(record, action, entity, rowIndex);
                break;
            }
            case "create": {
                props.onCreateRecord &&
                    props.onCreateRecord(record, action, entity, rowIndex);
                break;
            }
            case "edit": {
                props.onEditRecord &&
                    props.onEditRecord(record, action, entity, rowIndex);
                break;
            }
            case "nothing": {
                return;
            }
        }
        props.onClickRecord &&
            props.onClickRecord(record, action, entity, rowIndex);
    };
    var onClickTag = function (tag) {
        props.onClickTag && props.onClickTag(tag);
    };
    var onApplyConditions = function (conditions) {
        props.onApplyConditions && props.onApplyConditions(conditions);
    };
    var columns = getColumns(onClickRecord, entity, {
        showTags: showTags,
        onClickTag: onClickTag,
        recordInAction: recordInAction,
        onApplyConditions: onApplyConditions,
        context: currentContext
    });
    var hideHeader = (0, lodash_1.filter)(columns, function (c) { return (0, primeobjects_helper_util_1.isNonEmptyString)(c.title); }).length == 0;
    var tableWrapperHeightAdj = (props.showInfoHeader ? 2 : 0) + (props.showInfoFooter ? 2 : 0);
    var renderInfoHeader = function () {
        if (props.infoHeader)
            return props.infoHeader;
        return (react_1.default.createElement(react_1.default.Fragment, null,
            props.infoHeaderContent,
            react_1.default.createElement("span", { className: "text-xs leading-none" },
                "Count: ",
                (0, primeobjects_helper_util_1.numberWithCommas)(data.length))));
    };
    var renderInfoFooter = function () {
        if (props.infoFooter)
            return props.infoFooter;
        return (react_1.default.createElement(react_1.default.Fragment, null,
            props.infoFooterContent,
            (result === null || result === void 0 ? void 0 : result.continuation) && (react_1.default.createElement("span", { className: "text-xs cursor-pointer", onClick: onClickFooterLoadMore }, "More ..."))));
    };
    return (react_1.default.createElement("div", { className: "list-table-wrapper w-full h-full ".concat(wrapperClassName), style: wrapperStyle },
        props.showInfoHeader && (react_1.default.createElement("div", { className: "w-full h-8 py-2 px-4 flex flex-col items-end", style: {
                borderBottom: "1px solid #f0f0f0"
            } }, renderInfoHeader())),
        react_1.default.createElement("div", { className: "list-table w-full flex ".concat(hideHeader ? "hide-header" : "", " ").concat(tableWrapperClassName), style: __assign(__assign({}, tableWrapperStyle), { height: "calc(100% - ".concat(tableWrapperHeightAdj, "rem)") }) },
            react_1.default.createElement("div", { ref: tableSectionWrapper, className: "overflow-hidden overflow-y-auto w-full", onScroll: (0, lodash_1.throttle)(onScrollList, 500) },
                react_1.default.createElement(css_1.default, { id: "list-table-css", content: "\n                        ".concat((0, table_css_1.getListTableCSS)(primaryColor["600"]), "\n                        ").concat(showScrollbarX
                        ? ""
                        : ".list-table .ant-table-body::-webkit-scrollbar\n                            {\n                                width: 0px;\n                            }\n                            ", "\n                        ") }),
                data.length > 0 && (react_1.default.createElement(table_1.default, { scrollbarX: showScrollbarX, id: tableId, selectionType: props.selectionType, onRowSelected: onRowSelected, columns: columns, data: data, minWidth: minWidth })),
                renderLoading(),
                renderError(),
                renderEmpty(),
                renderLoadingMore())),
        props.showInfoFooter && (react_1.default.createElement("div", { className: "w-full h-8 py-2 px-4 flex flex-col items-end" }, renderInfoFooter()))));
};
exports.ListTableSection = ListTableSection;
exports.default = exports.ListTableSection;
//# sourceMappingURL=table.js.map