//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { isObject, libTrackIsOn } from "primeobjects-helper-util/build/cjs/core";
import { getCurrentPoolUser } from "./auth-cognito";
import { isEmpty } from "lodash";
import { callApiBase } from "../util";
export var callApi = function (solution, url, data, method, settings) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (!!solution.id) return [3 /*break*/, 2];
                return [4 /*yield*/, callApiBase(url, data, method, settings)];
            case 1: return [2 /*return*/, _a.sent()];
            case 2:
                if (!isObject(settings))
                    settings = {};
                if (settings)
                    settings.solutionId = solution.id;
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        getCurrentPoolUser(solution)
                            .then(function (cognito) {
                            if (settings)
                                settings.headers = {};
                            if (settings && !isEmpty(cognito)) {
                                if (!isObject(settings.headers))
                                    settings.headers = {};
                                if (settings.headers) {
                                    settings.headers.Authorization =
                                        cognito.signInUserSession.idToken.jwtToken;
                                    settings.headers.AccessToken =
                                        cognito.signInUserSession.accessToken.jwtToken;
                                }
                            }
                            if (libTrackIsOn())
                                console.log("getCurrentPoolUser->yes->callApiBase");
                            callApiBase(url, data, method, settings)
                                .then(resolve)
                                .catch(function (error) {
                                reject(error);
                            });
                        })
                            .catch(function () {
                            if (libTrackIsOn())
                                console.log("getCurrentPoolUser->no->callApiBase");
                            callApiBase(url, data, method, settings)
                                .then(resolve)
                                .catch(function (error) {
                                reject(error);
                            });
                        });
                    })];
        }
    });
}); };
//# sourceMappingURL=auth-call-api.js.map