//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from "react";
import { isFunction, map, without, isNil } from "lodash";
import { isNonEmptyString } from "primeobjects-helper-util";
import { SVG } from "primeobjects-ui-web-basic";
import Dropdown from "./antd/dropdown";
import Popconfirm from "./antd/popconfirm";
import Menu from "./antd/menu";
export var renderActionButton = function (menuItems, onClick, entity, settings) {
    var onValidMenuItem = settings === null || settings === void 0 ? void 0 : settings.onValidMenuItem;
    var onClickDiv = function (e) {
        var _a, _b, _c;
        if (isNonEmptyString((_a = e.target) === null || _a === void 0 ? void 0 : _a.className) &&
            ((_c = (_b = e.target) === null || _b === void 0 ? void 0 : _b.className) === null || _c === void 0 ? void 0 : _c.indexOf("action-button-wrapper")) >= 0) {
            e.target
                .getElementsByClassName("action-button-dropdown")[0]
                .click();
        }
    };
    return {
        title: "",
        id: "id",
        dataIndex: "id",
        key: "action-button",
        width: 40,
        fixed: "right",
        className: "clickable-cell",
        render: function (id, record, rowIndex) {
            var r = __assign({ id: id }, record);
            var currentMenuItems = without(map(menuItems, function (menuItem, index) {
                var isValid = !onValidMenuItem ||
                    (onValidMenuItem && onValidMenuItem(menuItem, record));
                return isValid ? (React.createElement(Menu.Item, { key: "action-button-menu-".concat(index), className: "w-full", onClick: function () {
                        isNil(menuItem.confirmationTitle) &&
                            onClick(r, menuItem.action, entity, rowIndex);
                    } }, !isNil(menuItem.confirmationTitle) ? (React.createElement(Popconfirm, { placement: "left", okType: menuItem.confirmationType, title: menuItem.confirmationTitle, onConfirm: function () {
                        onClick(r, menuItem.action, entity, rowIndex);
                    }, okText: "Yes", cancelText: "No" }, menuItem.title)) : (React.createElement("span", null, menuItem.title)))) : null;
            }), null);
            var menu = currentMenuItems.length > 0 && (React.createElement(Menu, null, currentMenuItems));
            var wrapperClassName = isFunction(settings === null || settings === void 0 ? void 0 : settings.onRenderWrapperClassName)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderWrapperClassName(record)
                : "";
            var wrapperStyle = isFunction(settings === null || settings === void 0 ? void 0 : settings.onRenderWrapperStyle)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderWrapperStyle(record)
                : {};
            var cellClassName = isFunction(settings === null || settings === void 0 ? void 0 : settings.onRenderCellClassName)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderCellClassName(record)
                : "";
            var cellStyle = isFunction(settings === null || settings === void 0 ? void 0 : settings.onRenderCellStyle)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderCellStyle(record)
                : {};
            var iconClassName = isFunction(settings === null || settings === void 0 ? void 0 : settings.onRenderIconClassName)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderIconClassName(record)
                : {};
            var iconColor = isFunction(settings === null || settings === void 0 ? void 0 : settings.onRenderIconColor)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderIconColor(record)
                : "#000000";
            var icon = (settings === null || settings === void 0 ? void 0 : settings.onGetIconUrl)
                ? settings === null || settings === void 0 ? void 0 : settings.onGetIconUrl(record)
                : record.uiDoing
                    ? "/icons/platform/loading.svg"
                    : "/icons/platform/menu-vertical.svg";
            return menu ? (React.createElement("div", { className: "action-button-wrapper w-full h-full flex justify-center flex-col p-0 ".concat(record.uiDisabled
                    ? "cursor-not-allowed"
                    : "cursor-pointer", " ").concat(cellClassName), style: cellStyle, onClick: onClickDiv },
                React.createElement(Dropdown, { disabled: record.uiDisabled, trigger: ["click"], overlay: menu, placement: "bottomLeft" },
                    React.createElement("div", { className: "action-button-dropdown w-full flex justify-center ".concat(wrapperClassName), style: wrapperStyle },
                        React.createElement(SVG, { id: "action-button-svg list-col-icon-action-button", color: iconColor, src: icon, className: "h-4 w-4 ".concat(record.uiDoing ? "spinner" : "", " ").concat(iconClassName) }))))) : (React.createElement(React.Fragment, null));
        }
    };
};
//# sourceMappingURL=action-menu.js.map