var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useEffect, useState } from "react";
import { Radio } from "antd";
import { CSS } from "primeobjects-ui-web-store/build/cjs/css";
import { libTrackIsOn } from "primeobjects-helper-util/build/cjs/core";
import { slug } from "primeobjects-helper-util/build/cjs/slug";
import { COLORS } from "primeobjects-helper-util/build/cjs/colors";
if (libTrackIsOn())
    console.log("Load Ant Radio.Group");
var RadioGroup = React.forwardRef(function (props, ref) {
    var color = props.color;
    var _a = useState(undefined), css = _a[0], setCss = _a[1];
    useEffect(function () {
        var className = "antd-radio-".concat(slug(color), "-css");
        setCss(color && {
            className: className,
            content: "\n                    .".concat(className, " .ant-radio-button-wrapper-checked:not(.ant-radio-button-wrapper-disabled) {\n                        color: ").concat(color, " !important;\n                        background: #fff;\n                        border-color: ").concat(color, " !important;\n                    }\n\n                    .").concat(className, " .ant-radio-button-wrapper-checked:not(.ant-radio-button-wrapper-disabled)::before\n                    {\n                        background-color: ").concat(color, " !important;\n                    }\n                    .ant-radio-button-wrapper {\n                        color: ").concat(COLORS.GRAY["700"], ";\n                        outline: none !important;\n                        box-shadow: none !important;\n                    }\n                    .ant-radio-button-wrapper:hover {\n                        color: ").concat(COLORS.GRAY["800"], ";\n                    }\n                ")
        });
    }, [color]);
    return (React.createElement(React.Fragment, null,
        css && color && React.createElement(CSS, { id: css.className, content: css.content }),
        React.createElement(Radio.Group, __assign({ className: css ? css.className : "" }, props, { ref: ref }))));
});
RadioGroup.displayName = "RadioGroup";
export default RadioGroup;
//# sourceMappingURL=radio-group.js.map