//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
import { isNonEmptyString } from "primeobjects-helper-util/build/cjs/core";
import React from "react";
import { SVG } from "primeobjects-ui-web-basic/build/cjs/controls/svg";
import { COLORS } from "primeobjects-helper-util/build/cjs/colors";
export var PageError = function (props) {
    var title = props.title ? props.title : "System Error";
    var description = props.description
        ? props.description
        : "Sorry. There was a problem. Please try again later.";
    var reason = props.reason ? props.reason : "Unknown";
    var iconSrc = isNonEmptyString(props.iconSrc)
        ? props.iconSrc
        : "/icons/platform/bug.svg";
    return (React.createElement("div", { className: "flex flex-col h-screen my-auto items-center bg-cover py-10" },
        React.createElement("div", { className: "flex flex-col border border-red-200 rounded-xl p-4 m-auto" },
            React.createElement("div", { className: "flex w-full pb-2" },
                React.createElement("div", { className: "flex items-center" },
                    React.createElement(SVG, { id: "loader_icon", src: iconSrc, color: COLORS.RED["600"], className: "h-8 w-8", size: 50 })),
                React.createElement("div", { className: "flex-1 ml-5 " },
                    React.createElement("h1", { className: "font-semibold text-lg text-gray-800" }, title),
                    React.createElement("div", { className: "text-gray-600" }, description),
                    React.createElement("div", { className: "text-gray-600" },
                        "Reason: ",
                        reason))))));
};
export default PageError;
//# sourceMappingURL=error.js.map