//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
import React, { useState, useEffect } from "react";
import { isArray, isNil, filter } from "lodash";
export var ListEmptySection = function (props) {
    var entity = props.entity, search = props.search, tags = props.tags;
    var hasSearch = !isNil(search);
    var hasTags = isArray(tags) && tags.length > 0;
    var _a = useState(false), hasCategories = _a[0], setHasCategories = _a[1];
    useEffect(function () {
        setHasCategories(props.nodes && props.nodes.length > 0
            ? filter(props.nodes, function (node) {
                return node.entityName == "Category";
            }).length > 0
            : false);
    }, [props.nodes]);
    return (React.createElement("div", { className: "w-full p-4 flex flex-col" },
        React.createElement("span", { className: "text-base text-gray-700 pb-4" },
            "There is no ",
            entity.uiName,
            " returned from the query."),
        (hasSearch || hasTags || hasCategories) && (React.createElement(React.Fragment, null,
            React.createElement("p", null,
                React.createElement("b", null, "Hope the tips below can help you.")),
            React.createElement("ul", null,
                hasSearch && (React.createElement("li", null, "* Check the spelling of your keyword")),
                hasTags && (React.createElement("li", null, "* Check the spelling of your tag(s)")),
                hasSearch && (React.createElement("li", null, "* Broaden your search by using fewer or more general word(s)")),
                hasTags && (React.createElement("li", null, "* Broaden your search by using fewer or more general tag(s)")),
                !hasCategories && (React.createElement("li", null, "* Select one or more categories to filter by categories")),
                !hasTags && (React.createElement("li", null, "* Select one or more tags to filter by tags")))))));
};
export default ListEmptySection;
//# sourceMappingURL=empty.js.map