//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from "react";
import { observer } from "mobx-react-lite";
import { useContextStore } from "primeobjects-ui-web-store";
import Avatar from "primeobjects-ui-web-basic/build/cjs/controls/avatar";
export var MeNavItem = observer(function (props) {
    var contextStore = useContextStore();
    var context = JSON.parse(contextStore.data);
    var user = context.user;
    // const realtimeNetworkConnected = useCurrentRealtimeNetwork();
    // useEffect(() => {
    //     if (realtimeNetworkConnected) {
    //         context.user.currentStatus = "on";
    //         contextStore.setData(context);
    //     }
    // }, [realtimeNetworkConnected]);
    var menuItems = props.menuItems ? props.menuItems : [];
    if (props.onClickSignOut)
        menuItems.unshift({
            title: "Sign Out",
            onClick: function () {
                if (props.onClickSignOut)
                    props.onClickSignOut(user);
            }
        });
    if (props.onClickUserProfile)
        menuItems.unshift({
            title: "Your Profile",
            onClick: function () {
                if (props.onClickUserProfile)
                    props.onClickUserProfile(user);
            }
        });
    return (React.createElement(Avatar, __assign({}, props, { menuItems: menuItems, data: user, onClick: props.onClick })));
});
export default MeNavItem;
//# sourceMappingURL=me.js.map