//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from "react";
import SiteSection from "./site-section";
import { isNonEmptyString } from "primeobjects-helper-util";
import SiteRecordContentSection from "./site-record-content";
import SiteSimilarSectionInternal from "./site-similar";
import SiteTagsSection from "./site-tags";
import { usePrimaryColorName } from "primeobjects-helper-ui";
import { isArray } from "lodash";
import { getGlobalComponent } from "../util";
var SiteSimilarSection = undefined;
export var SiteRecordSection = function (props) {
    if (!SiteSimilarSection) {
        console.log("Get global components in /sections/site-record.tsx");
        SiteSimilarSection = getGlobalComponent("SiteSimilarSection", SiteSimilarSectionInternal);
    }
    var solution = props.solution;
    var colorName = usePrimaryColorName(solution);
    var submitEmailSettings = props.submitEmailSettings, record = props.record, tagSectionTitle = props.tagSectionTitle, similarSectionTitle = props.similarSectionTitle, urlTemplate = props.urlTemplate, similarSectionAdditionalData = props.similarSectionAdditionalData, flushCache = props.flushCache, wrapperClassName = props.wrapperClassName, wrapperStyle = props.wrapperStyle;
    var maxTagCount = props.maxTagCount ? props.maxTagCount : 100;
    var tags = isArray(record.tags) ? record.tags.slice(0, maxTagCount) : [];
    if (!isNonEmptyString(record.colorName))
        record.colorName = colorName;
    return (React.createElement(SiteSection, { className: "relative ".concat(wrapperClassName !== null && wrapperClassName !== void 0 ? wrapperClassName : ""), style: wrapperStyle !== null && wrapperStyle !== void 0 ? wrapperStyle : {} },
        React.createElement("div", { className: "max-w-7xl mx-auto" },
            React.createElement("div", { className: "flex flex-col lg:flex-row relative w-full" },
                React.createElement("div", { className: "w-full md:max-w-2xl inline article mx-auto" },
                    React.createElement(SiteRecordContentSection, __assign({}, props.recordContentProps, { solution: solution, titleSize: "h1", titleClassName: "mt-0", disableShorten: true, tags: tags, summary: record.summary, sourceUrl: record.sourceUrl, title: record.title, media: record.media, mediaSize: record.mediaSize, needHeaderPhoto: record.needHeaderPhoto, content: record.content, submitEmailSettings: submitEmailSettings, colorName: colorName, wrapperClassName: "mx-auto w-full overflow-hidden" }))),
                React.createElement("div", { className: "article w-full flex-1 mt-10 flex flex-col lg:border-l lg:pl-10 lg:ml-10 lg:mt-0 md:max-w-2xl mx-auto" },
                    React.createElement(SiteTagsSection, { data: tags, disableShorten: true, colorName: colorName, wrapperClassName: "mb-6", tagClassName: "hidden mr-4 mb-4 hover:bg-".concat(colorName, "-100 lg:flex"), tagBorderClassName: "border-gray-100 shadow", titleClassName: "hidden lg:flex", title: tagSectionTitle, titleSize: "h2" }),
                    React.createElement(SiteSimilarSection, { entityName: record.entityName, solution: solution, flushCache: flushCache, cacheKey: "record-similar", wrapperClassName: "mb-6", feedType: "id", feedValue: record.id, scope: "global-and-organization", globalOrganizationId: record.organizationId, additionalData: similarSectionAdditionalData, urlTemplate: urlTemplate, title: similarSectionTitle, titleSize: "h2" }))))));
};
export default SiteRecordSection;
//# sourceMappingURL=site-record.js.map